import type { IPFS } from "ipfs-core";
import { CID } from "multiformats/cid";
import { Options as LRUOptions } from "lru-cache";
export interface Link {
    [name: string]: CID | undefined;
}
export declare class Shard {
    private ipfs;
    cid: CID;
    private storeContext?;
    private constructor();
    private static encode;
    private static decode;
    static from(ipfs: IPFS, cid: CID, storeContext?: {
        key: string;
        store: Store;
    }): Promise<Shard>;
    static create(ipfs: IPFS, data: any, storeContext?: {
        key: string;
        store: Store;
    }): Promise<Shard>;
    get(): Promise<any | null>;
    private refreshStore;
    set(data: any): Promise<void>;
    /**
     * **Links are EXPERIMENTAL**
     */
    links(): Promise<Link>;
    /**
     * **Links are EXPERIMENTAL**
     */
    addLink(name: string, cid: CID): Promise<void>;
    /**
     * **Links are EXPERIMENTAL**
     */
    rmLink(cid: CID): Promise<void>;
}
export declare class Store {
    ipfs: IPFS;
    id: string;
    private cache;
    constructor(ipfs: IPFS, id: string, cache?: LRUOptions<string, CID>);
    private getDHTKey;
    setDHT(key: string, value: CID): Promise<void>;
    set(key: string, data: any): Promise<Shard>;
    get(key: string, timeout?: number): Promise<Shard>;
}
